use std::fs;

use pest::Parser;
use pest_derive::Parser;

#[derive(Parser)]
#[grammar = "rpy.pest"]
struct RpyParser;

pub fn parse(file_path: &str) {
    let unparsed_file = fs::read_to_string(file_path).expect("cannot find file");
    let file = RpyParser::parse(Rule::file, &unparsed_file)
        .expect("unsuccessful parse") // unwrap the parse result
        .next().unwrap(); // get and unwrap the `file` rule; never fails

    for record in file.into_inner() {
        match record.as_rule() {
            Rule::line => {
                for field in record.into_inner().map(|pairs| pairs.as_str()) {
                    println!("'{field}'");
                }
            },
            Rule::EOI => (),
            _ => unreachable!(),
        }
    }
}
